<?php
// $Id: uc_views.views.inc,v 1.8 2009/03/25 11:12:37 madsph Exp $
/**
 * @file
 * Views 2 hooks and callback registries.
 */

/**
 * Implementation of hook_views_data().
 */
function uc_views_views_data() {
  //Make the uc_order_products table visible for Views module
  $data['uc_order_products']['table']['group'] = t('Order product');
  $data['uc_order_products']['table']['join']['node'] = array(
      'left_field' => 'nid',
      'field' => 'nid',
  );

  $data['uc_order_products']['model'] = array(
    'title' => t('SKU'),
    'help' => t('The model number.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  $data['uc_order_products']['qty'] = array(
    'title' => t('qty'),
    'help' => t('The amount ordered.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products']['price'] = array(
    'title' => t('Price'),
    'help' => t("The Price."),
    'field' => array(
      'handler' => 'uc_product_handler_field_price',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products']['cost'] = array(
    'title' => t('Cost'),
    'help' => t('The cost of the product to the store.'),
    'field' => array(
      'handler' => 'uc_product_handler_field_price',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );

  $data['uc_order_products']['ordering'] = array(
    'title' => t('List position'),
    'help' => t('The default sort criteria in the catalog.'),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );


  //Make the uc_order_products_qty_vw view visible for Views module
  $data['uc_order_products_qty_vw']['table']['group'] = t('Order product');
  $data['uc_order_products_qty_vw']['table']['join']['node'] = array(
      'left_field' => 'nid',
      'field' => 'nid',
  );
  $data['uc_order_products_qty_vw']['order_count'] = array(
    'title' => t('order_count'),
    'help' => t('The number of orderlines with the product.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_qty_vw']['avg_qty'] = array(
    'title' => t('avg_qty'),
    'help' => t('The average amount ordered.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_qty_vw']['sum_qty'] = array(
    'title' => t('sum_qty'),
    'help' => t('The summed amount of all orders.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_qty_vw']['max_qty'] = array(
    'title' => t('max_qty'),
    'help' => t('The maximum amount ordered.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_qty_vw']['min_qty'] = array(
    'title' => t('min_qty'),
    'help' => t('The minimum amount ordered.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_qty_vw']['ordering'] = array(
    'title' => t('List position'),
    'help' => t('The default sort criteria in the catalog.'),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );


  //Make the uc_order_products_user_vw view visible for Views module
  $data['uc_order_products_user_vw']['table']['group'] = t('Order product');
  $data['uc_order_products_user_vw']['table']['join']['node'] = array(
      'left_field' => 'nid',
      'field' => 'nid',
  );
  $data['uc_order_products_user_vw']['table']['join']['users'] = array(
      'left_field' => 'uid',
      'field' => 'uid',
  );
  $data['uc_order_products_user_vw']['uid'] = array(
    'title' => t('user_id'),
    'help' => t('The id of the user.'),
    'field' => array(
      'handler' => 'views_handler_field_user',
      'click sortable' => TRUE,
    ),
     'argument' => array(
      'handler' => 'views_handler_argument_user_uid',
      'name field' => 'name', // the field to display in the summary.
      'numeric' => TRUE,
      'validate type' => 'uid',
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_user_vw']['order_count'] = array(
    'title' => t('user_order_count'),
    'help' => t('The number of orderlines with the product for the user.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_user_vw']['avg_qty'] = array(
    'title' => t('user_avg_qty'),
    'help' => t('The average amount ordered for the user.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_user_vw']['sum_qty'] = array(
    'title' => t('user_sum_qty'),
    'help' => t('The summed amount of all orders for the user.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_user_vw']['max_qty'] = array(
    'title' => t('user_max_qty'),
    'help' => t('The maximum amount ordered for the user.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_user_vw']['min_qty'] = array(
    'title' => t('user_min_qty'),
    'help' => t('The minimum amount ordered for the user.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_user_vw']['ordering'] = array(
    'title' => t('List position'),
    'help' => t('The default sort criteria in the catalog.'),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );


  //Make the uc_order_products_pair_vw view visible for Views module
  $data['uc_order_products_pair_vw']['table']['group'] = t('Order product');
  $data['uc_order_products_pair_vw']['table']['join']['node'] = array(
      'left_field' => 'nid',
      'field' => 'pair_nid',
  );
  $data['uc_order_products_pair_vw']['nid'] = array(
    'title' => t('pairs_product_nid'),
    'help' => t('The nid of the product for which we are seeking pairs.'),
    'field' => array(
      'handler' => 'views_handler_field_node',
      'click sortable' => TRUE,
    ),
     'argument' => array(
      'handler' => 'views_handler_argument_node_nid',
      'name field' => 'title', // the field to display in the summary.
      'numeric' => TRUE,
      'validate type' => 'nid',
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_pair_vw']['pair_nid'] = array(
    'title' => t('pairs_product_pair_nid'),
    'help' => t('The nid of the pair product.'),
    'field' => array(
      'handler' => 'views_handler_field_node',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_pair_vw']['order_count'] = array(
    'title' => t('pairs_order_count'),
    'help' => t('The number of orders in which the product pair has occured along with the product with nid.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_pair_vw']['pair_sum_qty'] = array(
    'title' => t('pairs_sum_qty'),
    'help' => t('The summed qty purchased on orders which also include the product with nid.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_order_products_pair_vw']['ordering'] = array(
    'title' => t('List position'),
    'help' => t('The default sort criteria in the catalog.'),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  //Make the uc_orders table visible for Views module
  //Thank you river_t for the Patch!
  $data['uc_orders']['table']['group'] = t('Order');
  $data['uc_orders']['table']['join']['node'] = array(
      'left_table' => 'uc_order_products',
      'left_field' => 'order_id',
      'field' => 'order_id',
  );
  $data['uc_orders']['order_id'] = array(
    'title' => t('Order ID'),
    'help' => t('The order ID'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_orders']['order_status'] = array(
    'title' => t('Order Status'),
    'help' => t('The order status'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_order_status',
    ),
  );
  $data['uc_orders']['uid'] = array(
    'title' => t('Order User ID'),
    'help' => t('The user ID for the order'),
    'field' => array(
      'handler' => 'views_handler_field_user',
      'click sortable' => TRUE,
    ),
     'argument' => array(
      'handler' => 'views_handler_argument_user_uid',
      'name field' => 'name', // the field to display in the summary.
      'numeric' => TRUE,
      'validate type' => 'uid',
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'relationship' => array(
      'base' => 'users',
      'field' => 'uid',
      'handler' => 'views_handler_relationship',
      'label' => t('Order User'),
    ),
  );
  $data['uc_orders']['order_total'] = array(
    'title' => t('Order total'),
    'help' => t('The total amount sold in the order'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_orders']['delivery_country'] = array(
    'title' => t('Order Delivery Country'),
    'help' => t('The country the order is delivered to'),
    'field' => array(
      'handler' => 'uc_views_handler_field_country',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'uc_views_handler_filter_country',
    ),
  );
  $data['uc_orders']['delivery_zone'] = array(
    'title' => t('Order Delivery Zone'),
    'help' => t('The zone the order is delivered to'),
    'field' => array(
      'handler' => 'uc_views_handler_field_zone',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'uc_views_handler_filter_zone',
    ),
  );
  $data['uc_orders']['delivery_city'] = array(
    'title' => t('Order Delivery City'),
    'help' => t('The city the order is delivered to'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  $data['uc_orders']['delivery_postal_code'] = array(
    'title' => t('Order Delivery Postal Code'),
    'help' => t('The postal code the order is delivered to'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  $data['uc_orders']['billing_country'] = array(
    'title' => t('Order Billing Country'),
    'help' => t('The country the order is billed to'),
    'field' => array(
      'handler' => 'uc_views_handler_field_country',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'uc_views_handler_filter_country',
    ),
  );
  $data['uc_orders']['billing_zone'] = array(
    'title' => t('Order Billing Zone'),
    'help' => t('The zone the order is billed to'),
    'field' => array(
      'handler' => 'uc_views_handler_field_zone',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'uc_views_handler_filter_zone',
    ),
  );
  $data['uc_orders']['billing_city'] = array(
    'title' => t('Order Billing City'),
    'help' => t('The city the order is billed to'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  $data['uc_orders']['billing_postal_code'] = array(
    'title' => t('Order Billing Postal Code'),
    'help' => t('The postal code the order is billed to'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  $data['uc_orders']['payment_method'] = array(
    'title' => t('Order Payment Method'),
    'help' => t('The payment method of the order'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  $data['uc_orders']['created'] = array(
    'title' => t('Order Creation Date'),
    'help' => t('The date the order was created'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
  );
  $data['uc_orders']['modified'] = array(
    'title' => t('Order Modification Date'),
    'help' => t('The date the order was last modified'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
  );

  //Make the uc_cart_products table visible for Views module
  $data['uc_cart_products']['table']['group'] = t('Cart product');
  $data['uc_cart_products']['table']['join']['node'] = array(
      'left_field' => 'nid',
      'field' => 'nid',
  );
  $data['uc_cart_products']['table']['join']['users'] = array(
      'left_field' => 'uid',
      'field' => 'cart_id',
  );
  $data['uc_cart_products']['nid'] = array(
    'title' => t('Cart product id'),
    'help' => t('The nid of the product for in a cart.'),
    'field' => array(
      'handler' => 'views_handler_field_node',
      'click sortable' => TRUE,
    ),
     'argument' => array(
      'handler' => 'views_handler_argument_node_nid',
      'name field' => 'title', // the field to display in the summary.
      'numeric' => TRUE,
      'validate type' => 'nid',
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_cart_products']['cart_id'] = array(
    'title' => t('Cart id'),
    'help' => t('The id of the cart (either user or session id).'),
    'field' => array(
      'handler' => 'uc_views_handler_field_cart_user',
      'click sortable' => TRUE,
    ),
     'argument' => array(
      'handler' => 'views_handler_argument_user_uid',
      'name field' => 'name', // the field to display in the summary.
      'numeric' => TRUE,
      'validate type' => 'cart_id',
    ),
     'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_cart_products']['qty'] = array(
    'title' => t('qty'),
    'help' => t('The amount ordered.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
  );
  $data['uc_cart_products']['changed'] = array(
    'title' => t('Cart Product Line Changed Date'),
    'help' => t('The date the cart line was changed'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
     'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
  );

  $data['uc_cart_products']['ordering'] = array(
    'title' => t('List position'),
    'help' => t('The default sort criteria in the catalog.'),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  return $data;
}

/**
 * Implementation of hook_views_handlers().
 */
function uc_views_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'uc_views') . '/views',
    ),
    'handlers' => array(
      // filters
      'uc_views_handler_field_country' => array('parent' => 'views_handler_field',),
      'uc_views_handler_field_cart_user' => array('parent' => 'views_handler_field',),
      'uc_views_handler_field_zone' => array('parent' => 'views_handler_field',),
      'views_handler_filter_order_status' => array('parent' => 'views_handler_filter_in_operator',),
      'uc_views_handler_filter_country' => array('parent' => 'views_handler_filter_in_operator',),
      'uc_views_handler_filter_zone' => array('parent' => 'views_handler_filter_in_operator',),
    ),
  );
}

/**
 * Conditionally add editablefields support.
 */
function uc_views_views_tables_alter(&$tables) {
}

